package jmsltestsuite;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.softsynth.jmsl.score.*;

public class BigNoteheadStemPlacement {
	ScoreFrame scoreFrame;
	Score score;

	void build() {
		score = new Score(1, 1400, 600);
		score.addMeasure();
		score.addNote(1, 65, 0.5, 0.8);
		score.addNote(1, 76, 0.5, 0.8);

		for (int i = 0; i < 4; i++) {
			Note n = score.addNote(0.25, 65, 0.5, 0.8);
			n.setBeamedOut(i < 3);
		}
		for (int i = 0; i < 4; i++) {
			Note n = score.addNote(0.25, 76, 0.5, 0.8);
			n.setBeamedOut(i < 3);
		}

		score.getScoreLayoutManager().setZoom(2);
		score.getControlPanel().setZoom(2);

		scoreFrame = new ScoreFrame();
		scoreFrame.addScore(score);
		scoreFrame.pack();
		scoreFrame.setVisible(true);

		scoreFrame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});

	}

	public static void main(String[] args) {
		new BigNoteheadStemPlacement().build();
	}

}
