/*
 * Created on Oct 17, 2004 
 *
 */
package jmsltestsuite;

import java.awt.GridLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.didkovsky.portview.PVFrame;
import com.didkovsky.portview.awt.ViewFactoryAWT;
import com.didkovsky.portview.swing.ViewFactorySwing;
import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.Score;

/**
 * Switch between AWT and Swing. Put a couple of Score Canvases in a window. All
 * components adapt to AWT or Swing
 * 
 * @author Nick Didkovsky, nick@didkovsky.com
 *  
 */
public class DualUseGraphicsScoreTest {

    public DualUseGraphicsScoreTest() {

        boolean useSwing = false;

        String title;
        if (useSwing) {
            title = "Two Swing Score Canvases";
            JMSL.setViewFactory(new ViewFactorySwing());
        } else {
            title = "Two AWT Score Canvases";
            JMSL.setViewFactory(new ViewFactoryAWT());
        }

        PVFrame frame = JMSL.getViewFactory().createFrame();
        frame.setTitle(title + ", (c) Nick Didkovsky, 2004");
        Score.useSharedCanvas(false);

        Score score1 = new Score(1, 300, 100);
        score1.addMeasure();
        score1.addNote(1.0, 60, 0.5, 0.8);
        score1.addNote(1.0, 62, 0.5, 0.8);
        score1.addNote(1.0, 64, 0.5, 0.8);
        score1.addNote(1.0, 66, 0.5, 0.8);

        Score score2 = new Score(1, 300, 100);
        score2.addMeasure();
        score2.addNote(1.0, 70, 0.5, 0.8);
        score2.addNote(1.0, 72, 0.5, 0.8);
        score2.addNote(1.0, 74, 0.5, 0.8);
        score2.addNote(1.0, 76, 0.5, 0.8);

        frame.setFrameLayout(new GridLayout(0, 1));
        frame.add(score1.getScoreCanvas().getComponent());
        frame.add(score2.getScoreCanvas().getComponent());

        frame.setSize(600, 250);

        frame.setVisible(true);

        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }

    public static void main(String[] args) {
        new DualUseGraphicsScoreTest();
    }

}