/*
 * Created by Nick on Feb 23, 2005
 * 
 * A ScheduledEvent can be posted into the future with a timestamp and will execute then.
 *
 */
package jmsltestsuite;

import com.softsynth.jmsl.*;


public class EventExample implements ScheduledEvent {

	private String msg;
	private double playTime;
	
	public EventExample(double playTime, String msg) {
		this.msg = msg;
		this.playTime = playTime;
	}
	
	public double getPlayTime() {
		return playTime;
	}
	
	public void play() {
		JMSL.out.println(msg + ", firing at playTime: " + playTime + ", scheduling error: " + (JMSL.now()-playTime));
	}
	

	public static void main(String args[]) {
		EventScheduler scheduler = new EventScheduler();
		scheduler.start();
		scheduler.post(new EventExample(JMSL.now() + 4.0, "Ho there"));
		scheduler.post(new EventExample(JMSL.now() + 3.0, "Hi there"));
		scheduler.post(new EventExample(JMSL.now() + 2.0, "Hey there"));
		scheduler.post(new EventExample(JMSL.now() - 10, "In the past"));
	}
	
}