package jmsltestsuite;

import com.softsynth.jmsl.JMSL;

/**
 * List midi ports by name <br>
 * <br>
 * Not very useful as of JMSL's default MidiShare implementation. MidiShare does
 * not currently return # devices or the device names to Java. Some future
 * version of MidiShare might, at which point JMSL can tell you about it. <BR>
 * 
 * Useful if you are using MidiPort, however.
 * 
 * @author Nick Didkovsky 2/27/01
 * 
 */
public class ListMidiDevices {

	public static void main(String args[]) {
//		JMSL.midi = com.softsynth.jmsl.midi.MidiIO_MidiShare.instance();
		JMSL.midi = com.softsynth.jmsl.midi.MidiIO_JavaSound.instance();
		String names[] = JMSL.midi.getInputDeviceNames();
		for (int i = 0; i < names.length; i++) {
			JMSL.out.println("MIDI Input Device: (" + i + ") " + names[i]);
		}
		JMSL.out.println();
		names = JMSL.midi.getOutputDeviceNames();
		for (int i = 0; i < names.length; i++) {
			JMSL.out.println("MIDI Output Device: (" + i + ") " + names[i]);
		}
		System.exit(0);
	}
}