package jmsltestsuite;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import com.softsynth.midifile.MIDIFileInputStream;
import com.softsynth.midifile.MIDIFileListener;

public class MIDIFileListenerTest implements MIDIFileListener {

	public void handleHeader(int format, int numTracks, short division) {
		System.out.println("MIDIFileListenerTest.handleHeader(" + format + ", " + numTracks + ", " + division);

	}

	public void handleBeginTrack(int index) {
		System.out.println("MIDIFileListenerTest.handleBeginTrack(" + index + ")");

	}

	public void handleEndTrack(int index) {
		System.out.println("MIDIFileListenerTest.handleEndTrack(" + index + ")");

	}

	public void handleSysExF0(int ticks, byte[] b) {
		System.out.println("MIDIFileListenerTest.handleSysExF0(" + ticks + ")");

	}

	public void handleSysExF7(int ticks, byte[] b) {
		System.out.println("MIDIFileListenerTest.handleSysExF7(" + ticks + ")");

	}

	public void handleMetaEvent(int ticks, int type, byte[] b) {
		System.out.println("MIDIFileListenerTest.handleMetaEvent(" + type + ")");

	}

	public void handleEvent(int ticks, int command, int data1, int data2) {
		System.out.println("MIDIFileListenerTest.handleEvent(" + command + ")");

	}

	public static void main(String[] args) {
		String filename = "D:/documents/JMSLScoreWork/bugs/2606.mid";
		MIDIFileListenerTest midiFileListenerTest = new MIDIFileListenerTest();
		FileInputStream stream;
		try {
			stream = new FileInputStream(new File(filename));
			MIDIFileInputStream parser = new MIDIFileInputStream(stream);
			parser.addMIDIFileListener(midiFileListenerTest);
			parser.parse();
//			System.out.println("PARSE DONE");
			stream.close();
//			System.out.println("CLOSED");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		System.out.println("TEST DONE");
	}
}
