package jmsltestsuite;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.didkovsky.portview.swing.ViewFactorySwing;
import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.*;

/**
 * 
 * Test various notehead types
 * 
 * @author Nick Didkovsky, copyright 2005 Nick Didkovsky
 */
public class NoteOverrideLevelTest {

    Score score;
    int numStaves;

    public NoteOverrideLevelTest() {
        int w = 1000;
        int h = 750;
        numStaves = 1;
        score = new Score(numStaves, w, h);
        build();
    }

  
    public void build() {
        score.addMeasure(4, 4);
        for (int i = 0; i < 8; i++) {
            Note n = score.addNote(0.5, 60, 0.5, 0.8);
            n.setOverrideLevel(Staff.LEVEL_OF_BOTTOM_LINE + i);
            n.setOverrideLevel(true);
           System.out.println(Staff.LEVEL_OF_BOTTOM_LINE + ", " + n.getLevel());
            
        }
        score.getScoreLayoutManager().setZoom(0.5);
        score.getControlPanel().setZoom(0.5);
    }

    public static void main(String args[]) {
        JMSL.setViewFactory(new ViewFactorySwing());
        NoteOverrideLevelTest test = new NoteOverrideLevelTest();
        ScoreFrame scoreFrame = new ScoreFrame();
        scoreFrame.addScore(test.score);
        scoreFrame.pack();
        scoreFrame.setVisible(true);
        scoreFrame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }

}