/*
 * Created on May 27, 2007 by Nick
 *
 */
package jmsltestsuite;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.didkovsky.portview.swing.ViewFactorySwing;
import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.*;

/** turn note visibility on/off under program control *
 * 
 * @author Nick Didkovsky, (c) 2005 Nick Didkovsky, nick@didkovsky.com
 *
 */
public class NoteVisiblityTest {
    public static void main(String[] args) {
        JMSL.setViewFactory(new ViewFactorySwing());
        Score score = new Score(1, 800, 600);
        Measure m = score.addMeasure();
        m.setMeasureText("drag-select all notes below and hit the n key to toggle visibility");
        m.setDoubleBar(true);
        m = score.addMeasure();
        m.setPeriodDoubleBar(true);
        
        Note n = score.addNote(1.0, 60, 0.5, 0.8);
        n.setVisible(true);
        n = score.addNote(1.0, 61, 0.5, 0.8);
        n.setVisible(false);
        n.setTiedOut(true);
        n = score.addNote(1.0, 61, 0.5, 0.8);
        n.setVisible(false);
        n = score.addNote(1.0, 63, 0.5, 0.8);
        n.setVisible(true);
        
        Note n2 = NoteFactory.makeNote(0.2, 80, 0.6, 2.0);
        n.addInterval(n2);
        
        
        ScoreFrame scoreFrame = new ScoreFrame();
        scoreFrame.addScore(score);
        scoreFrame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        scoreFrame.pack();
        scoreFrame.setVisible(true);
    }
}
