package jmsltestsuite;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.*;

/**  
 * demonstrates bigger measure numbering font and ability to have each measure display measure number
 * For Jason Freeman 11-14-2011
 * 
 * controls over all other font names and scales
 * also for jason freeman 1/17/2012
 * 
 *  
 * @author Nick Didkovsky, copyright 2012 
*/
public class ScoreFontNamesAndScaling {

	public static void main(String args[]) {
		int w = 1100;
		int h = 800;
		int numStaves = 1;
		Score score = new Score(numStaves, w, h, "Font names and scaling");
		score.setScoreSubtitle("subtitle is nice");
		score.addMeasure();
		
		// new methods
		score.setMeasureNumberFontScaler(3.0);
		score.setScoreTitleFontScaler(12.0);
		score.setScoreSubtitleFontScaler(8.0);
		score.setTimesigFontScaler(3.0);
		score.setTextFontScaler(1.5);
					
		
		score.setMeasureNumberFontName("Serif");
		score.setScoreTitleFontName("SansSerif");
		score.setScoreSubtitleFontName("SansSerif");
		score.setTimesigFontName("Serif");
		score.setTextFontName("SansSerif");
		
		// new method
		score.setDrawAllMeasureNumbers(true);
		
		for (int i = 0; i < 40; i++) {
			score.addNote(4, NoteFactory.MIDDLE_C, 0.5, 3.2);
		}
		ScoreFrame scoreFrame = new ScoreFrame();
		scoreFrame.addScore(score);
		scoreFrame.setVisible(true);

		scoreFrame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				JMSL.closeMusicDevices();
				System.exit(0);
			}
		});
	}
}