package jmsltestsuite;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.didkovsky.portview.swing.ViewFactorySwing;
import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.Score;
import com.softsynth.jmsl.score.ScoreFrame;
import com.softsynth.jmsl.util.HarmonicComplexity;

/**
 * 
 */
public class ScoreHarmComplexityTest {

    Score score;
    ScoreFrame scoreFrame;

    public ScoreHarmComplexityTest() {
        int w = 640;
        int h = 300;

        score = new Score(1, w, h);
        score.addMeasure();
        scoreFrame = new ScoreFrame();
        scoreFrame.addScore(score);

        build();
    }

    public void build() {
        double basePitch = 52;
        int numPitches = HarmonicComplexity.harmComplexArr.length;
        for (int i = 0; i < numPitches; i++) {
            double duration = 4;
            double pitch = basePitch + HarmonicComplexity.harmComplexArr[i];
            score.addNote(duration, pitch, 0.5, duration * 0.8);
        }
    }

    public static void main(String args[]) {

        // Score.setTempoVisible(false);

        JMSL.setViewFactory(new ViewFactorySwing());
        ScoreHarmComplexityTest st = new ScoreHarmComplexityTest();
        st.scoreFrame.pack();
        st.scoreFrame.setVisible(true);
        
        st.scoreFrame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }

}