package jmsltestsuite;

import java.awt.FlowLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.didkovsky.portview.PVPanel;
import com.didkovsky.portview.swing.ViewFactorySwing;
import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.Score;
import com.softsynth.jmsl.score.ScoreFrame;

/**
 * 
 * 
 * @author Nick Didkovsky and Phil Burk, copyright 2000 Nick Didkovsky and Phil
 *         Burk
 */
public class SimpleScoreTest {

	Score score;
	ScoreFrame scoreFrame;
	

	public SimpleScoreTest() {
		int w = 600;
		int h = 300;
	
		scoreFrame = new ScoreFrame();
		score = new Score(1, w, h);
		
		scoreFrame.addScore(score);
		
		PVPanel p = JMSL.getViewFactory().createPanel();
		p.setLayout(new FlowLayout(FlowLayout.LEFT));
		p.add(score.getControlPanel().getComponent());
		
		build();
		
		scoreFrame.pack();
		scoreFrame.setVisible(true);
	}


	public void build() {
		score.addMeasure();
		score.addNote(1.0, 60, 0.5, 0.80);
		score.addNote(1.0, 60, 0.5, 0.80);
		score.addNote(0.666, 65, 0.5, 0.80);
		score.addNote(0.666, 65, 0.5, 0.80);
		score.addNote(0.666, 65, 0.5, 0.80);
	}

	public static void main(String args[]) {

		JMSL.setViewFactory(new ViewFactorySwing());
		SimpleScoreTest st = new SimpleScoreTest();

		st.scoreFrame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
	}

}