package jmsltestsuite;

import java.util.Vector;

import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.MusicShape;
import com.softsynth.jmsl.score.*;
import com.softsynth.jmsl.score.transcribe.*;
import com.softsynth.jmsl.util.TimeSignature;

/**

2011-11-10	wrote to to fix transcriber bug which was revealed for chord, fixed now

2011-11-14, this revealed another bug though: first rest should be quarter note but it shows up as 16th+dotted8th rests
			aha - fixed . Caused by negative hold times (Georg H uses these) which interacted badly with recent 
			feature which extends transcription data with an element whose event time comes after last hold time
			
 * @author Nick Didkovsky, (c) 2011 Nick Didkovsky, All Rights reserved.
 */

public class TranscribeScore16 {

	public static void main(String args[]) {
		JMSL.clock.setAdvance(0.1);
		BeatDivisionSchemeList.defaultSetup();

		boolean SEE_BUG = true;
		
		MusicShape sourceBug = new MusicShape(5);
//		sourceBug.add(1.1363929510116577, 50.0, 64.0, -1.0, 0.0);
//		sourceBug.add(1.3051639795303345, 61.0, 64.0, -1.0, 0.0);
		
		if (SEE_BUG) {
			sourceBug.add(1.5, 50.0, 64.0, -1, 0.0);
			
//			sourceBug.add(2.5, 50.0, 64.0, 3, 0.0);
			
		} else {
			sourceBug.add(1.5, 50.0, 64.0, 0.4, 0.0);
		}

		// 1 staff, width, height
		Score score = new Score(1, 1024, 800);
		score.addMeasure();
		
		Transcriber transcriber = new Transcriber();
		transcriber.setExtendLastHoldTime(true);
		transcriber.setScore(score);

		transcriber.setSourceMusicShape(sourceBug);

		Vector tsVector = new Vector();
		tsVector.addElement(new TempoTimeSignatureHolder(new Tempo(60), new TimeSignature(2, 4)));

		transcriber.setTempoTimeSignatures(tsVector);

		try {
			score.setCurrentStaffNumber(0);
			transcriber.transcribe();
		} catch (ElementMissedException e) {
			e.printStackTrace();
			System.out.println("ERROR: " + e);
			System.exit(0);
		} catch (SearchPathListExpansionException e) {
			e.printStackTrace();
			System.out.println("ERROR: " + e);
			System.exit(0);
		}

		final ScoreFrame f = new ScoreFrame();
		f.addScore(score);
		// f.loadPrefs();
		f.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				f.quit();
			}
		});

		f.setVisible(true);

	}

}
