package jmsltestsuite;

import java.util.Vector;

import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.MusicShape;
import com.softsynth.jmsl.score.Score;
import com.softsynth.jmsl.score.ScoreFrame;
import com.softsynth.jmsl.score.Tempo;
import com.softsynth.jmsl.score.transcribe.BeatDivisionSchemeList;
import com.softsynth.jmsl.score.transcribe.ElementMissedException;
import com.softsynth.jmsl.score.transcribe.SearchPathListExpansionException;
import com.softsynth.jmsl.score.transcribe.TempoTimeSignatureHolder;
import com.softsynth.jmsl.score.transcribe.Transcriber;
import com.softsynth.jmsl.util.TimeSignature;

/**
 
 * 
 * This test examines minute differences in timestamp
 * 
 
 * 
 @author Nick Didkovsky, (c) 2002 Nick Didkovsky, All Rights reserved.
 */

public class TranscribeScore21 {

	

	public static void main(String args[]) {
		JMSL.clock.setAdvance(0.1);
		BeatDivisionSchemeList.defaultSetup();

		
		MusicShape source1 = new MusicShape(4);
		source1.add( 0., 65, 0.5, 4. );
		source1.add(  4., 65, 0.5, 2 );
		// 2 staves, width, height
		Score score = new Score(1, 1024, 800);
		score.addMeasure();
		
		Transcriber transcriber = new Transcriber();
//		transcriber.setExtendLastHoldTime(true);  		
		 
		Vector tsVector = new Vector();
		tsVector.addElement( new TimeSignature(4, 4));
		transcriber.setTimeSignatures(tsVector);
 
		try {
			score.setCurrentStaffNumber(0);
			transcriber.setScore(score);			
			score.rewind();
			transcriber.setSourceMusicShape(source1);
			transcriber.transcribe();
			
			
		} catch (ElementMissedException e) {
			e.printStackTrace();
			System.out.println("ERROR: " + e);
			System.exit(0);
		} catch (SearchPathListExpansionException e) {
			e.printStackTrace();
			System.out.println("ERROR: " + e);
			System.exit(0);
		}

		final ScoreFrame f = new ScoreFrame();
		f.addScore(score); 
		f.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				f.quit();
			}
		});

		f.setVisible(true);

	}

}
