package jmsltestsuite.jsyn2;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.*;

import com.softsynth.jmsl.*;
import com.softsynth.jmsl.jsyn2.JSynMusicDevice;
import com.softsynth.jmsl.jsyn2.SamplePlayingInstrument;

public class TestSamplePlayingInstrument extends JFrame {

    private SamplePlayingInstrument instrument;
    private JMSLMixerContainer mixer;

    private JButton noteOnButton;
    private JButton noteOffButton;

    private Object voiceToken = -1;

    TestSamplePlayingInstrument() {
        noteOnButton = new JButton("Note on");
        noteOffButton = new JButton("Note off");
        noteOffButton.setEnabled(false);
        JPanel p = new JPanel();
        p.setLayout(new FlowLayout());
        p.add(noteOnButton);
        p.add(noteOffButton);
        add(BorderLayout.SOUTH, p);

        noteOnButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ev) {
                noteOffButton.setEnabled(true);
                noteOnButton.setEnabled(false);
                System.out.println("button noteon");
                double[] dar = { 1.0, 60, 0.6, 0.8 };
                voiceToken = instrument.on(JMSL.now(), 1.0, dar);
            }

        });

        noteOffButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ev) {
                noteOffButton.setEnabled(false);
                noteOnButton.setEnabled(true);
                System.out.println("button noteoff");
                instrument.off(voiceToken, JMSL.now());
            }

        });
    }

    void buildMixer() {
        mixer = new JMSLMixerContainer();        
        mixer.start();
        mixer.addInstrument(instrument);
    }

    public void buildInstrument() {
        instrument = new SamplePlayingInstrument();
        instrument.setPlaybackMode(SamplePlayingInstrument.SAMPLE_CROSSFADED_LOOPING);
        instrument.getMusicDevice().open();

//        instrument.setDirectory(new File("D:/documents/JMSLScoreWork/JMSLScoreSamples/SIEDLACZEK/cello_bowed"));
//        instrument.addSamplePitch("c4.wav", 60);
         instrument.setDirectory(new File("D:/documents/JMSLScoreWork/JMSLScoreSamples/voice"));
         instrument.addSamplePitch("CountToTwenty_1ch.wav", 60);

        // instrument.addSamplePitch("yves/SopranoSaxShort.wav", 65);
        // instrument.addSamplePitch("yves/SopranoSaxOctave.wav", 77);

        instrument.buildFromAttributes();
    }

    public static void main(String args[]) {

        JMSL.clock.setAdvance(0.2);

        final TestSamplePlayingInstrument test = new TestSamplePlayingInstrument();
        test.buildInstrument();
        test.buildMixer();

        MusicJob jSynUsageJob = new MusicJob() {
            public double repeat(double playTime) throws InterruptedException {
                System.out.println("JSyn usage: " + JSynMusicDevice.instance().getSynthesizer().getUsage());
                return playTime + 0.2;
            }
        };

        jSynUsageJob.setRepeats(10000);
        // jSynUsageJob.launch(JMSL.now());

        test.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent e) {
                JMSL.closeMusicDevices();
                System.exit(0);
            }
        });
        test.add(test.mixer.getPanAmpControlPanel());

        test.pack();
        test.setVisible(true);
    }

}
