package jmsltestsuite.jsyn2;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.JMSLMixerContainer;
import com.softsynth.jmsl.MusicShape;
import com.softsynth.jmsl.jsyn2.SamplePlayingInstrument;

public class TestVoiceAllocator {

	private MusicShape musicShape;
	private SamplePlayingInstrument instrument;
	private JMSLMixerContainer mixer;

	void buildMelody() {
		musicShape = new MusicShape(4);
//		musicShape.setDimensionName(0, "duration");
//		musicShape.setLimits(0, 0.0, 8.0);
//		musicShape.setDefault(0, 1.0);
//		musicShape.setDimensionName(1, "pitch");
//		musicShape.setLimits(1, 0.0, 127.0);
//		musicShape.setDefault(1, 60.0);
//		musicShape.setDimensionName(2, "amplitude");
//		musicShape.setLimits(2, 0.0, 1.0);
//		musicShape.setDefault(2, 0.5);
//		musicShape.setDimensionName(3, "hold");
//		musicShape.setLimits(3, 0.0, 8.0);
//		musicShape.setDefault(3, 0.8);
		
		musicShape.add(0.25, 40.0, 0.5, 0.2);
		musicShape.add(0.25, 43.0, 0.5, 0.2);
		musicShape.add(0.25, 45.0, 0.5, 0.2);
		musicShape.add(0.25, 49.0, 0.5, 0.2);
		musicShape.add(0.25, 45.0, 0.5, 0.2);
		musicShape.add(0.25, 43.0, 0.5, 0.2);
		musicShape.add(0.25, 44.0, 0.5, 0.2);				
		musicShape.add(0.25, 43.0, 0.5, 0.2);
		musicShape.add(0.25, 40.0, 0.5, 0.2);
		musicShape.add(0.25, 42.0, 0.5, 0.2);
		musicShape.add(0.25, 43.0, 0.5, 0.2);
		musicShape.add(0.25, 44.0, 0.5, 0.2);
		musicShape.add(0.25, 40.0, 0.5, 0.2);
		musicShape.add(0.25, 44.0, 0.5, 0.2);
		musicShape.add(0.25, 45.0, 0.5, 0.2);
		musicShape.add(0.25, 46.0, 0.5, 0.2);
		musicShape.add(0.25, 40.0, 0.5, 0.2);
		musicShape.add(0.25, 43.0, 0.5, 0.2);
		musicShape.add(0.25, 45.0, 0.5, 0.2);
		musicShape.add(0.25, 49.0, 0.5, 0.2);
		musicShape.add(0.25, 45.0, 0.5, 0.2);				
		musicShape.add(0.25, 43.0, 0.5, 0.2);
		musicShape.add(0.25, 44.0, 0.5, 0.2);
		musicShape.add(0.25, 43.0, 0.5, 0.2);
		musicShape.add(0.25, 40.0, 0.5, 0.2);
		musicShape.add(0.25, 42.0, 0.5, 0.2);
		musicShape.add(0.25, 43.0, 0.5, 0.2);
		musicShape.add(0.25, 44.0, 0.5, 0.2);
		musicShape.add(0.25, 40.0, 0.5, 0.2);
		musicShape.add(0.25, 44.0, 0.5, 0.2);
		musicShape.add(0.25, 45.0, 0.5, 0.2);						 
		musicShape.add(0.25, 46.0, 0.5, 0.2);
		
		
		musicShape.add(0.25, 55.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 54.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 53.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 54.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.0, 62.0, 0.5, 0.4);
		musicShape.add(0.5, 55.0, 0.5, 0.4);
		musicShape.add(0.0, 63.0, 0.5, 0.4000000000000001);
		musicShape.add(0.5, 56.0, 0.5, 0.4000000000000001);
		musicShape.add(0.25, 55.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 54.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 53.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 54.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.0, 62.0, 0.5, 0.4);
		musicShape.add(0.5, 55.0, 0.5, 0.4);
		musicShape.add(0.0, 63.0, 0.5, 0.4000000000000001);
		musicShape.add(0.5, 56.0, 0.5, 0.4000000000000001);
		musicShape.add(0.25, 55.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 54.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 53.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 54.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.25, 52.0, 0.5, 0.2);
		musicShape.add(0.0, 62.0, 0.5, 0.4);
		musicShape.add(0.5, 55.0, 0.5, 0.4);
		musicShape.add(0.0, 63.0, 0.5, 0.4000000000000001);
		musicShape.add(0.5, 56.0, 0.5, 0.4000000000000001);
		musicShape.setInstrument(instrument);
	}

	void buildMixer() {
		mixer = new JMSLMixerContainer();
		mixer.addInstrument(instrument);
		mixer.start();
	}

	protected void play() {
		musicShape.setTimeStretch(60.0 / 100.0); // 100bpm
		musicShape.setRepeats(Integer.MAX_VALUE);
		musicShape.launch(JMSL.now());
	}

	public void buildInstrument() {
		instrument = new SamplePlayingInstrument();
		instrument.setDirectory(new File("D:/documents/JMSLScoreWork/JMSLScoreSamples"));
		instrument.getMusicDevice().open();

		instrument.addSamplePitch("kawai_k1m/guitar/gtr52.wav", 52);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr55.wav", 55);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr58.wav", 58);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr61.wav", 61);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr64.wav", 64);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr67.wav", 67);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr70.wav", 70);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr73.wav", 73);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr76.wav", 76);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr79.wav", 79);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr82.wav", 82);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr85.wav", 85);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr88.wav", 88);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr91.wav", 91);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr94.wav", 94);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr97.wav", 97);
		instrument.addSamplePitch("kawai_k1m/guitar/gtr100.wav", 100);

		instrument.buildFromAttributes();
	}

	public static void main(String args[]) {

		JMSL.clock.setAdvance(0.2);

		final TestVoiceAllocator test = new TestVoiceAllocator();
		test.buildInstrument();
		test.buildMixer();
		test.buildMelody();

		java.awt.Frame f = new java.awt.Frame("JSyn2 TestVoiceAllocator");
		f.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				JMSL.closeMusicDevices();
				System.exit(0);
			}
		});
		f.add(test.mixer.getPanAmpControlPanel());
		Button stopButton;
		f.add(BorderLayout.SOUTH, stopButton = new Button("Start"));
		f.pack();
		f.setVisible(true);
		
		stopButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {				
				test.play();
			}
		});
		f.pack();

	}

}
