/** 	
	MJToot05.java <br><br>

	PrintingJob is a subclass of MusicJob, whose repeat() method
	is overridden to give it custom functionality.
	
	Prints a message every repeat.
		
 * @author Phil Burk and Nick Didkovsky
 */
/*
 * (C) 1997 Phil Burk and Nick Didkovsky, All Rights Reserved
 * JMSL is based upon HMSL (C) Phil Burk, Larry Polansky and David Rosenboom.
 */

package jmsltutorial;

import com.softsynth.jmsl.*;

public class MJToot05 extends java.applet.Applet {

	PrintingJob spot;
	PrintingJob puff;

	/* Build our PrintingJobs when applet initializes */
	public void init() {
	    spot = new PrintingJob("Bow-wow");
		puff = new PrintingJob("Meow");

		spot.setRepeatPause(2.0);
		puff.setRepeatPause(1.0);

		spot.setRepeats(50);
		puff.setRepeats(100);

	}

	/* When applet starts up, launch them */
	public void start() {
		JMSL.clock = new DefaultMusicClock();
		JMSL.setSTDOut(new DefaultSTDOut());
		
		spot.launch(JMSL.now());
		puff.launch(JMSL.now());
	}

	/* Shut down the PrintingJobs when applet stops */
	public void stop() {
		puff.finish();
		spot.finish();
	}
}
